OpenTTD Source: TextfileWindow Struct Reference

OpenTTD Source 15.0-RC2

Data Structures | Public Member Functions | Data Fields | Protected Member Functions | Protected Attributes | Private Types | Private Member Functions | Private Attributes
TextfileWindow Struct Reference

Window for displaying a textfile. More...

`#include <textfile_gui.h>`

Inheritance diagram for TextfileWindow:

## Data Structures
struct | HistoryEntry
struct | Hyperlink
struct | Line

## Public Member Functions
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond) override
| Event to display a custom tooltip.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnResize () override
| Called after the window got resized.
void | OnInit () override
| Notification that the nested widget tree gets initialized.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
void | OnDropdownSelect (WidgetID widget, int index, int) override
| A dropdown option associated to this window has been selected.
void | OnRealtimeTick (uint delta_ms) override
| Called periodically.
void | OnScrollbarScroll (WidgetID widget) override
| Notify window that a scrollbar position has been updated.
void | Reset () override
| Reset the search, i.e.
FontSize | DefaultSize () override
| Get the default (font) size of the string.
std::optional< std::string_view > | NextString () override
| Get the next string to search through.
bool | Monospace () override
| Whether to search for a monospace font or not.
void | SetFontNames (FontCacheSettings *settings, std::string_view font_name, const void *os_data) override
| Set the right font names.
void | ScrollToLine (size_t line)
bool | IsTextWrapped () const
virtual void | LoadTextfile (const std::string &textfile, Subdirectory dir)
| Loads the textfile text from file and setup lines.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (size_t from, size_t to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, std::string_view str, bool marked, std::optional< size_t > caret, std::optional< size_t > insert_location, std::optional< size_t > replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
Window * | FindChildWindowById (WindowClass wc, WindowNumber number) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | CloseChildWindowById (WindowClass wc, WindowNumber number) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual std::string | GetWidgetString (WidgetID widget, StringID stringid) const
| Get the raw string for a widget.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel, WidgetID widget)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, int click_result, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual void | OnQueryTextFinished (std::optional< std::string > str)
| The query window opened from this window has closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from MissingGlyphSearcher
virtual | ~MissingGlyphSearcher ()=default
| Make sure everything gets destructed right.
bool | FindMissingGlyphs ()
| Check whether there are glyphs missing in the current language.

## Data Fields
TextfileType | file_type {}
| Type of textfile to view.
Scrollbar * | vscroll = nullptr
| Vertical scrollbar.
Scrollbar * | hscroll = nullptr
| Horizontal scrollbar.
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags {}
| Window flags.
WindowClass | window_class {}
| Window class.
WindowNumber | window_number = 0
| Window number within the window class.
int | scale = 0
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer = 0
| Timer value of the WindowFlag::Timeout for flags.
uint8_t | white_border_timer = 0
| Timer value of the WindowFlag::WhiteBorder for flags.
int | left = 0
| x position of left edge of the window
int | top = 0
| y position of top edge of the window
int | width = 0
| width of the window (number of pixels to the right in x direction)
int | height = 0
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize {}
| Resize information.
Owner | owner = INVALID_OWNER
| The owner of the content shown in this window. Company colour is acquired from this variable.
std::unique_ptr< ViewportData > | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus = nullptr
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings {}
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root {}
| Root of the nested tree.
WidgetLookup | widget_lookup {}
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select = nullptr
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size {}
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget = INVALID_WIDGET
| ID of current mouse capture widget (e.g. dragged scrollbar). `INVALID_WIDGET` if no widget has mouse capture.
Window * | parent = nullptr
| Parent window.
WindowList::iterator | z_position {}

## Protected Member Functions
| TextfileWindow (Window *parent, TextfileType file_type)
void | ConstructWindow ()
void | LoadText (std::string_view buf)
| Load a text into the textfile viewer.
void | FindHyperlinksInMarkdown (Line &line, size_t line_index)
| Find any hyperlinks in a given line.
virtual void | OnHyperlinkClick (const Hyperlink &link)
| Handle the clicking on a hyperlink.
virtual void | AfterLoadText ()
| Post-processing after the text is loaded.
void | NavigateToFile (std::string newfile, size_t line)
| Navigate to the requested file.
void | AppendHistory (const std::string &filepath)
| Append the new location to the history, so the user can go back.
void | UpdateHistoryScrollpos ()
| Update the scroll position to the current, so we can restore there if we go back.
void | NavigateHistory (int delta)
| Navigate through the history, either forward or backward.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height, bool allow_resize)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.

## Protected Attributes
std::string | filename {}
| Filename of the textfile.
std::string | filepath {}
| Full path to the filename.
std::vector< Line > | lines {}
| #text, split into lines in a table with lines.
std::vector< size_t > | jumplist {}
| Table of contents list, line numbers.
std::vector< Hyperlink > | links {}
| Clickable links in lines.
std::vector< Hyperlink > | link_anchors {}
| Anchor names of headings that can be linked to.
std::vector< HistoryEntry > | history {}
| Browsing history in this window.
size_t | history_pos = 0
| Position in browsing history (for forward movement).
bool | trusted = false
| Whether the content is trusted (read: not from content like NewGRFs, etc).
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data {}
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize = false
| Set if window has been resized.

## Private Types
enum class | ReflowState : uint8_t { None , Reflowed , VisibleReflowed }
using | LineIterator = std::vector< Line >::iterator
using | ReflowIterator = AlternatingIterator< LineIterator >

## Private Member Functions
std::vector< TextfileWindow::Line >::iterator | GetIteratorFromPosition (int pos)
void | UpdateVisibleIterators ()
void | ReflowContent ()
| Reset the reflow process to start on the next UI tick.
ReflowState | ContinueReflow ()
void | SetupScrollbars ()
| Set scrollbars to the right lengths.
const Hyperlink * | GetHyperlink (Point pt) const
| Get the hyperlink at the given position.
void | AfterLoadMarkdown ()
| Post-processing of markdown files.

## Private Attributes
uint | search_iterator = 0
| Iterator for the font check search.
int | max_width = 0
| Maximum length of unwrapped text line.
size_t | num_lines = 0
| Number of lines of text, taking account of wrapping.
ReflowIterator | reflow_iter
| Current iterator for reflow.
ReflowIterator | reflow_end
| End iterator for reflow.
LineIterator | visible_first
| Iterator to first visible element.
LineIterator | visible_last
| Iterator to last visible element.

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.

## Detailed Description

Window for displaying a textfile.

Definition at line 22 of file textfile_gui.h.

## Member Typedef Documentation

## ◆ LineIterator

using TextfileWindow::LineIterator = std::vector<Line>::iterator
| private

Definition at line 111 of file textfile_gui.h.

## ◆ ReflowIterator

using TextfileWindow::ReflowIterator = AlternatingIterator<LineIterator>
| private

Definition at line 112 of file textfile_gui.h.

## Member Enumeration Documentation

## ◆ ReflowState

enum class TextfileWindow::ReflowState : uint8_t
| strongprivate

Enumerator
None | Nothing has been reflowed.
Reflowed | Content has been reflowed.
VisibleReflowed | Visible content has been reflowed.

Definition at line 120 of file textfile_gui.h.

## Constructor & Destructor Documentation

## ◆ TextfileWindow()

TextfileWindow::TextfileWindow | ( | Window * | parent,
|  | TextfileType | file_type
| ) |  |
| protected

Definition at line 86 of file textfile_gui.cpp.

## Member Function Documentation

## ◆ AfterLoadMarkdown()

void TextfileWindow::AfterLoadMarkdown | ( |  | ) |
| private

Post-processing of markdown files.

Definition at line 487 of file textfile_gui.cpp.

References FindHyperlinksInMarkdown(), jumplist, lines, link_anchors, MakeAnchorSlug(), and TextfileWindow::Line::text.

Referenced by AfterLoadText().

## ◆ AfterLoadText()

void TextfileWindow::AfterLoadText | ( |  | ) |
| protectedvirtual

Post-processing after the text is loaded.

Reimplemented in GameManualTextfileWindow.

Definition at line 475 of file textfile_gui.cpp.

References AfterLoadMarkdown(), filename, jumplist, link_anchors, Window::ReInit(), StrEndsWithIgnoreCase(), SZSP_HORIZONTAL, and WID_TF_SEL_JUMPLIST.

Referenced by GameManualTextfileWindow::AfterLoadText(), and LoadText().

## ◆ AppendHistory()

void TextfileWindow::AppendHistory | ( | const std::string & | filepath | ) |
| protected

Append the new location to the history, so the user can go back.

Parameters

  filepath | The location the user is navigating to.

Definition at line 334 of file textfile_gui.cpp.

References Window::DisableWidget(), Window::EnableWidget(), history, history_pos, UpdateHistoryScrollpos(), WID_TF_NAVBACK, and WID_TF_NAVFORWARD.

Referenced by NavigateToFile(), and OnHyperlinkClick().

## ◆ ConstructWindow()

void TextfileWindow::ConstructWindow | ( |  | ) |
| protected

Definition at line 93 of file textfile_gui.cpp.

## ◆ ContinueReflow()

TextfileWindow::ReflowState TextfileWindow::ContinueReflow | ( |  | ) |
| private

Definition at line 633 of file textfile_gui.cpp.

## ◆ DefaultSize()

FontSize TextfileWindow::DefaultSize | ( |  | ) |
| overridevirtual

Get the default (font) size of the string.

Returns
  The font size.

Implements MissingGlyphSearcher.

Definition at line 745 of file textfile_gui.cpp.

References FS_MONO.

## ◆ DrawWidget()

void TextfileWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| overridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 549 of file textfile_gui.cpp.

References _current_text_dir, DrawString(), DrawStringMultiLineWithClipping(), FillDrawPixelInfo(), FILLRECT_CHECKER, FS_MONO, Scrollbar::GetCapacity(), GetCharacterHeight(), Scrollbar::GetPosition(), GfxFillRect(), hscroll, lines, PC_WHITE, reflow_end, reflow_iter, Window::resize, SA_LEFT, SA_TOP, WidgetDimensions::scaled, ScrollRect(), Rect::Shrink(), ResizeInfo::step_width, TD_RTL, Window::top, Rect::Translate(), vscroll, WID_TF_BACKGROUND, WID_TF_CAPTION, Rect::Width(), Rect::WithHeight(), and Rect::WithWidth().

## ◆ FindHyperlinksInMarkdown()

void TextfileWindow::FindHyperlinksInMarkdown | ( | Line & | line,
|  | size_t | line_index
| ) |  |
| protected

Find any hyperlinks in a given line.

Parameters

  line | The line to search for hyperlinks.
  line_index | The index of the line.

Definition at line 225 of file textfile_gui.cpp.

References _markdown_link_regex, TextfileWindow::Hyperlink::begin, ClassifyHyperlink(), TextfileWindow::Hyperlink::destination, TextfileWindow::Hyperlink::end, File, Internal, links, BaseStringBuilder::PutUtf8(), TextfileWindow::Line::text, and Web.

Referenced by AfterLoadMarkdown().

## ◆ GetHyperlink()

const TextfileWindow::Hyperlink * TextfileWindow::GetHyperlink | ( | Point | pt | ) | const
| private

Get the hyperlink at the given position.

Parameters

  pt | The point to check.

Returns
  The hyperlink at the given position, or nullptr if there is no hyperlink.

Definition at line 284 of file textfile_gui.cpp.

References Debug, WidgetDimensions::frametext, FS_MONO, GetCharacterHeight(), Scrollbar::GetPosition(), Window::GetRowFromWidget(), Window::GetScrollbar(), lines, links, TextfileWindow::Line::num_lines, WidgetDimensions::scaled, TextfileWindow::Line::text, WID_TF_BACKGROUND, WID_TF_VSCROLLBAR, Coord2D< T >::x, and Coord2D< T >::y.

Referenced by OnClick(), and OnTooltip().

## ◆ GetIteratorFromPosition()

std::vector< TextfileWindow::Line >::iterator TextfileWindow::GetIteratorFromPosition | ( | int | pos | ) |
| private

Definition at line 713 of file textfile_gui.cpp.

## ◆ IsTextWrapped()

bool TextfileWindow::IsTextWrapped | ( |  | ) | const

Definition at line 735 of file textfile_gui.cpp.

## ◆ LoadText()

void TextfileWindow::LoadText | ( | std::string_view | buf | ) |
| protected

Load a text into the textfile viewer.

This will split the text into newlines and stores it for fast drawing.

Parameters

  buf | The text to load.

Definition at line 907 of file textfile_gui.cpp.

References AfterLoadText(), AllowNewline, CheckForMissingGlyphs(), lines, ReflowContent(), Window::ReInit(), ReplaceTabCrNlWithSpace, ReplaceWithQuestionMark, and StrMakeValid().

Referenced by LoadTextfile().

## ◆ LoadTextfile()

void TextfileWindow::LoadTextfile | ( | const std::string & | textfile,
|  | Subdirectory | dir
| ) |  |
| virtual

Loads the textfile text from file and setup lines.

Definition at line 851 of file textfile_gui.cpp.

References filename, filepath, FioFOpenFile(), Gunzip(), history, jumplist, lines, LoadText(), Window::ReInit(), SZSP_HORIZONTAL, WID_TF_SEL_JUMPLIST, and Xunzip().

Referenced by NavigateHistory(), NavigateToFile(), and ScriptTextfileWindow::OnInvalidateData().

## ◆ Monospace()

bool TextfileWindow::Monospace | ( |  | ) |
| overridevirtual

Whether to search for a monospace font or not.

Returns
  True if searching for monospace.

Implements MissingGlyphSearcher.

Definition at line 757 of file textfile_gui.cpp.

## ◆ NavigateHistory()

void TextfileWindow::NavigateHistory | ( | int | delta | ) |
| protected

Navigate through the history, either forward or backward.

Parameters

  delta | The direction to navigate.

Definition at line 357 of file textfile_gui.cpp.

References filename, filepath, Window::GetScrollbar(), history, history_pos, LoadTextfile(), NO_DIRECTORY, Window::SetDirty(), Scrollbar::SetPosition(), Window::SetWidgetDisabledState(), UpdateHistoryScrollpos(), WID_TF_HSCROLLBAR, WID_TF_NAVBACK, WID_TF_NAVFORWARD, and WID_TF_VSCROLLBAR.

Referenced by OnClick().

## ◆ NavigateToFile()

void TextfileWindow::NavigateToFile | ( | std::string | newfile,
|  | size_t | line
| ) |  |
| protected

Navigate to the requested file.

Parameters

  newfile | The file to navigate to.
  line | The line to scroll to.

Definition at line 413 of file textfile_gui.cpp.

References AppendHistory(), TextfileWindow::Hyperlink::destination, filename, filepath, FioCheckFileExists(), Window::GetScrollbar(), link_anchors, LoadTextfile(), NO_DIRECTORY, Scrollbar::SetPosition(), StrEndsWithIgnoreCase(), UpdateHistoryScrollpos(), WID_TF_HSCROLLBAR, and WID_TF_VSCROLLBAR.

Referenced by OnHyperlinkClick().

## ◆ NextString()

std::optional< std::string_view > TextfileWindow::NextString | ( |  | ) |
| overridevirtual

Get the next string to search through.

Returns
  The next string or nullopt if there is none.

Implements MissingGlyphSearcher.

Definition at line 750 of file textfile_gui.cpp.

References lines, and search_iterator.

## ◆ OnClick()

void TextfileWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| overridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 504 of file textfile_gui.cpp.

References GetHyperlink(), GetString(), Window::InvalidateData(), jumplist, lines, NavigateHistory(), OnHyperlinkClick(), ShowDropDownList(), Window::ToggleWidgetLoweredState(), WID_TF_BACKGROUND, WID_TF_JUMPLIST, WID_TF_NAVBACK, WID_TF_NAVFORWARD, and WID_TF_WRAPTEXT.

## ◆ OnDropdownSelect()

void TextfileWindow::OnDropdownSelect | ( | WidgetID | widget,
|  | int | index,
|  | int | click_result
| ) |  |
| overridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 624 of file textfile_gui.cpp.

References WID_TF_JUMPLIST.

## ◆ OnHyperlinkClick()

void TextfileWindow::OnHyperlinkClick | ( | const Hyperlink & | link | ) |
| protectedvirtual

Handle the clicking on a hyperlink.

Parameters

  link | The link that is clicked on.

Definition at line 379 of file textfile_gui.cpp.

References AppendHistory(), ClassifyHyperlink(), TextfileWindow::Hyperlink::destination, File, filepath, Internal, link_anchors, NavigateToFile(), UpdateHistoryScrollpos(), and Web.

Referenced by OnClick().

## ◆ OnInit()

void TextfileWindow::OnInit | ( |  | ) |
| overridevirtual

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note
  nested_root and/or widget_lookup (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 602 of file textfile_gui.cpp.

References lines, max_width, num_lines, and ReflowContent().

## ◆ OnInvalidateData()

void TextfileWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| overridevirtual

Some data on this window has become invalid.

Parameters

  data | information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 616 of file textfile_gui.cpp.

References ReflowContent(), and SetupScrollbars().

## ◆ OnRealtimeTick()

void TextfileWindow::OnRealtimeTick | ( | uint | delta_ms | ) |
| overridevirtual

Called periodically.

Reimplemented from Window.

Definition at line 679 of file textfile_gui.cpp.

References None, SetupScrollbars(), Window::SetWidgetDirty(), VisibleReflowed, WID_TF_BACKGROUND, and WID_TF_CAPTION.

## ◆ OnResize()

void TextfileWindow::OnResize | ( |  | ) |
| overridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 592 of file textfile_gui.cpp.

References hscroll, ReflowContent(), WidgetDimensions::scaled, Scrollbar::SetCapacityFromWidget(), SetupScrollbars(), vscroll, and WID_TF_BACKGROUND.

## ◆ OnScrollbarScroll()

void TextfileWindow::OnScrollbarScroll | ( | WidgetID | widget | ) |
| overridevirtual

Notify window that a scrollbar position has been updated.

Note
  Only called when the user scrolls, not if a window moves its scrollbar.

Parameters

  widget | the scrollbar widget index.

Reimplemented from Window.

Definition at line 705 of file textfile_gui.cpp.

References ReflowContent(), and WID_TF_VSCROLLBAR.

## ◆ OnTooltip()

bool TextfileWindow::OnTooltip | ( | Point | pt,
|  | WidgetID | widget,
|  | TooltipCloseCondition | close_cond
| ) |  |
| overridevirtual

Event to display a custom tooltip.

Parameters

  pt | The point where the mouse is located.
  widget | The widget where the mouse is located.

Returns
  True if the event is handled, false if it is ignored.

Reimplemented from Window.

Definition at line 537 of file textfile_gui.cpp.

References TextfileWindow::Hyperlink::destination, GetEncodedString(), GetHyperlink(), GuiShowTooltips(), and WID_TF_BACKGROUND.

## ◆ ReflowContent()

void TextfileWindow::ReflowContent | ( |  | ) |
| private

Reset the reflow process to start on the next UI tick.

Definition at line 110 of file textfile_gui.cpp.

References Scrollbar::GetPosition(), lines, num_lines, reflow_end, reflow_iter, and vscroll.

Referenced by LoadText(), OnInit(), OnInvalidateData(), OnResize(), and OnScrollbarScroll().

## ◆ Reset()

void TextfileWindow::Reset | ( |  | ) |
| overridevirtual

Reset the search, i.e.

begin from the beginning again.

Implements MissingGlyphSearcher.

Definition at line 740 of file textfile_gui.cpp.

References search_iterator.

## ◆ ScrollToLine()

void TextfileWindow::ScrollToLine | ( | size_t | line | ) |

Definition at line 722 of file textfile_gui.cpp.

## ◆ SetFontNames()

void TextfileWindow::SetFontNames | ( | FontCacheSettings * | settings,
|  | std::string_view | font_name,
|  | const void * | os_data
| ) |  |
| overridevirtual

Set the right font names.

Parameters

  settings | The settings to modify.
  font_name | The new font name.
  os_data | Opaque pointer to OS-specific data.

Implements MissingGlyphSearcher.

Definition at line 762 of file textfile_gui.cpp.

References settings.

## ◆ SetupScrollbars()

void TextfileWindow::SetupScrollbars | ( |  | ) |
| private

Set scrollbars to the right lengths.

Definition at line 136 of file textfile_gui.cpp.

References CeilDiv(), hscroll, max_width, num_lines, Window::resize, Scrollbar::SetCount(), Window::SetWidgetDirty(), Window::SetWidgetDisabledState(), ResizeInfo::step_width, vscroll, WID_TF_HSCROLLBAR, and WID_TF_VSCROLLBAR.

Referenced by OnInvalidateData(), OnRealtimeTick(), and OnResize().

## ◆ UpdateHistoryScrollpos()

void TextfileWindow::UpdateHistoryScrollpos | ( |  | ) |
| protected

Update the scroll position to the current, so we can restore there if we go back.

Definition at line 347 of file textfile_gui.cpp.

References Scrollbar::GetPosition(), Window::GetScrollbar(), history, history_pos, and WID_TF_VSCROLLBAR.

Referenced by AppendHistory(), NavigateHistory(), NavigateToFile(), and OnHyperlinkClick().

## ◆ UpdateVisibleIterators()

void TextfileWindow::UpdateVisibleIterators | ( |  | ) |
| private

Definition at line 695 of file textfile_gui.cpp.

## ◆ UpdateWidgetSize()

void TextfileWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| overridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 122 of file textfile_gui.cpp.

References WidgetDimensions::frametext, FS_MONO, GetCharacterHeight(), Window::resize, WidgetDimensions::scaled, RectPadding::Vertical(), and WID_TF_BACKGROUND.

## Field Documentation

## ◆ file_type

TextfileType TextfileWindow::file_type {}

Type of textfile to view.

Definition at line 23 of file textfile_gui.h.

Referenced by ScriptTextfileWindow::OnInvalidateData().

## ◆ filename

std::string TextfileWindow::filename {}
| protected

Filename of the textfile.

Definition at line 75 of file textfile_gui.h.

Referenced by AfterLoadText(), LoadTextfile(), NavigateHistory(), and NavigateToFile().

## ◆ filepath

std::string TextfileWindow::filepath {}
| protected

Full path to the filename.

Definition at line 76 of file textfile_gui.h.

Referenced by LoadTextfile(), NavigateHistory(), NavigateToFile(), and OnHyperlinkClick().

## ◆ history

std::vector<HistoryEntry> TextfileWindow::history {}
| protected

Browsing history in this window.

Definition at line 82 of file textfile_gui.h.

Referenced by AppendHistory(), LoadTextfile(), NavigateHistory(), and UpdateHistoryScrollpos().

## ◆ history_pos

size_t TextfileWindow::history_pos = 0
| protected

Position in browsing history (for forward movement).

Definition at line 83 of file textfile_gui.h.

Referenced by AppendHistory(), NavigateHistory(), and UpdateHistoryScrollpos().

## ◆ hscroll

Scrollbar* TextfileWindow::hscroll = nullptr

Horizontal scrollbar.

Definition at line 25 of file textfile_gui.h.

Referenced by DrawWidget(), OnResize(), and SetupScrollbars().

## ◆ jumplist

std::vector<size_t> TextfileWindow::jumplist {}
| protected

Table of contents list, line numbers.

Definition at line 79 of file textfile_gui.h.

Referenced by AfterLoadMarkdown(), AfterLoadText(), LoadTextfile(), and OnClick().

## ◆ lines

std::vector<Line> TextfileWindow::lines {}
| protected

#text, split into lines in a table with lines.

Definition at line 78 of file textfile_gui.h.

Referenced by GameManualTextfileWindow::AfterLoadChangelog(), AfterLoadMarkdown(), DrawWidget(), GetHyperlink(), LoadText(), LoadTextfile(), NextString(), OnClick(), OnInit(), and ReflowContent().

## ◆ link_anchors

std::vector<Hyperlink> TextfileWindow::link_anchors {}
| protected

Anchor names of headings that can be linked to.

Definition at line 81 of file textfile_gui.h.

Referenced by AfterLoadMarkdown(), AfterLoadText(), GameManualTextfileWindow::AfterLoadText(), NavigateToFile(), and OnHyperlinkClick().

## ◆ links

std::vector<Hyperlink> TextfileWindow::links {}
| protected

Clickable links in lines.

Definition at line 80 of file textfile_gui.h.

Referenced by FindHyperlinksInMarkdown(), and GetHyperlink().

## ◆ max_width

int TextfileWindow::max_width = 0
| private

Maximum length of unwrapped text line.

Definition at line 108 of file textfile_gui.h.

Referenced by OnInit(), and SetupScrollbars().

## ◆ num_lines

size_t TextfileWindow::num_lines = 0
| private

Number of lines of text, taking account of wrapping.

Definition at line 109 of file textfile_gui.h.

Referenced by OnInit(), ReflowContent(), and SetupScrollbars().

## ◆ reflow_end

ReflowIterator TextfileWindow::reflow_end
| private

End iterator for reflow.

Definition at line 115 of file textfile_gui.h.

Referenced by DrawWidget(), and ReflowContent().

## ◆ reflow_iter

ReflowIterator TextfileWindow::reflow_iter
| private

Current iterator for reflow.

Definition at line 114 of file textfile_gui.h.

Referenced by DrawWidget(), and ReflowContent().

## ◆ search_iterator

uint TextfileWindow::search_iterator = 0
| private

Iterator for the font check search.

Definition at line 107 of file textfile_gui.h.

Referenced by NextString(), and Reset().

## ◆ trusted

bool TextfileWindow::trusted = false
| protected

Whether the content is trusted (read: not from content like NewGRFs, etc).

Definition at line 84 of file textfile_gui.h.

## ◆ visible_first

LineIterator TextfileWindow::visible_first
| private

Iterator to first visible element.

Definition at line 117 of file textfile_gui.h.

## ◆ visible_last

LineIterator TextfileWindow::visible_last
| private

Iterator to last visible element.

Definition at line 118 of file textfile_gui.h.

## ◆ vscroll

Scrollbar* TextfileWindow::vscroll = nullptr

Vertical scrollbar.

Definition at line 24 of file textfile_gui.h.

Referenced by DrawWidget(), OnResize(), ReflowContent(), and SetupScrollbars().

The documentation for this struct was generated from the following files:

- src/textfile_gui.h
- src/textfile_gui.cpp